----------------------------------------------------------------------------------
-- Company: CAL POLY SLO
-- Engineer: Mairead Blaes and Edwin Wong
-- 
-- Create Date:    12:57:23 12/04/2014 
-- Design Name: 
-- Module Name:    Display_Game_Outcome - Behavioral 
-- Project Name: CPE 133 Final Project
-- Target Devices: 
-- Tool versions: 
-- Description: Displays red LED's on external display when player's input is incorrect.
--					 Displays green LED's on Nexys 2 board when player's input is correct.
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Display_Game_Outcome is
    Port ( row : out  STD_LOGIC_VECTOR (7 downto 0);--rows of LED matrix
           column : out  STD_LOGIC_VECTOR (7 downto 0);--columns of LED matrix
			  LEDs: out STD_LOGIC_VECTOR(3 downto 0);
           game_output : in  STD_LOGIC);--inputs the game state (win or lose)
end Display_Game_Outcome;

architecture Behavioral of Display_Game_Outcome is

begin


row <= "11111111" when (game_output = '1') else
		"00000000";
		
column <= "00000000" when (game_output = '1') else
		"11111111";
		
LEDs <= "1111" when (game_output = '1') else "0000";


end Behavioral;

