----------------------------------------------------------------------------------
-- Company: CAL POLY SLO
-- Engineer: Mairead Blaes and Edwin Wong
-- 
-- Create Date:    12:47:57 12/04/2014 
-- Design Name: 
-- Module Name:    Game_State - Behavioral 
-- Project Name: CPE 133 Final Project
-- Target Devices: 
-- Tool versions: 
-- Description: Controls the state, win or lose, the game is in.
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Game_State is
    Port ( equal : in  STD_LOGIC; --equal to
           less : in  STD_LOGIC; --less than
           greater : in  STD_LOGIC; --greater than
			  CLR: in STD_LOGIC;
			  CLK: in STD_LOGIC;
			  game_output: out STD_LOGIC);--win or lose
end Game_State;

architecture Behavioral of Game_State is

	type state_type is (win, lose);
	signal PS, NS: state_type;--PS is present state and NS is next state

begin
	sync_proc: process(CLK, NS, CLR)
	begin
		
		if(CLR = '1') then
			PS <= lose;
		elsif (rising_edge(CLK)) then
			PS <= NS;
		end if;
	end process sync_proc; 

-----------------------------------------------------------------------
--The game is in state "lose" when the player's input does not match
--the output of the seven-segment display.
--
--The game is in state "win" when the player's input does match the
--the output of the seven-segment display.
------------------------------------------------------------------------  	
	comb_proc: process(PS, equal, less, greater)
	begin
		game_output <= '0';
		case PS is
			when lose =>
				game_output <= '0';
				if (equal = '1' and less ='0' and greater = '0') then 
					NS <= win;
				else NS <= lose;
				end if;
			when win => 
				game_output <= '1';
				if (equal= '1' and less ='0' and greater = '0') then 
					NS <= win;
				else NS <= lose;
				end if;
	
			when others =>
				game_output <= '0';
				NS <= lose;
		end case;
	end process comb_proc;

end Behavioral;

