----------------------------------------------------------------------------------
-- Company: CAL POLY SLO
-- Engineer: Mairead Blaes and Edwin Wong
-- 
-- Create Date:    12:06:09 12/03/2014 
-- Design Name: 
-- Module Name:    Linear_FB_Register - Behavioral 
-- Project Name: CPE 133 Final Project
-- Target Devices: 
-- Tool versions: 
-- Description: Used linear feedback register to generate random numbers. The output is an 8 bit random number. 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Linear_FB_Register is
    Port ( lfsr8_out : out  STD_LOGIC_VECTOR(7 downto 0);--random 8 bit number
           clk : in  STD_LOGIC;
           reset : in  STD_LOGIC);
end Linear_FB_Register;

architecture Behavioral of Linear_FB_Register is
	signal lfsr: std_logic_vector(7 downto 0);
	signal lfsr_next: std_logic_vector(7 downto 0);

begin
	lfsr_seq: process(clk, reset)
	begin
	
		if(rising_edge(clk)) then
			if reset = '1' then
				lfsr <= x"0F";--will reset to 00001111
			else
				lfsr <= lfsr_next;--goes to next random number 
			end if;
		end if;
	end process lfsr_seq;
	
	lfsr_comb: process(lfsr, clk, reset)
	begin
		lfsr_next(7 downto 1) <= lfsr(6 downto 0);
		lfsr_next(0) <= lfsr(7) xor lfsr(1);
	end process lfsr_comb;
	
	lfsr8_out <= lfsr;

end Behavioral;

