----------------------------------------------------------------------------------
-- Company: CAL POLY SLO
-- Engineer: Mairead Blaes and Edwin Wong
-- 
-- Create Date:    10:24:56 12/04/2014 
-- Design Name: 
-- Module Name:    Random_Num_display - Behavioral 
-- Project Name: CPE 133 Final Project
-- Target Devices: 
-- Tool versions: 
-- Description: Displays a random number on the seven-segment display.
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Random_Num_display is
    Port ( clk : in  STD_LOGIC;
           en, reset_btn : in  STD_LOGIC;--buttons on board
           segments : out  STD_LOGIC_VECTOR (7 downto 0);
           anodes : out  STD_LOGIC_VECTOR (3 downto 0);
			  D_num_out: inout STD_LOGIC_VECTOR(7 downto 0));--the latched number output from D_FF
end Random_Num_display;

architecture Behavioral of Random_Num_display is

component D_FF is
	port(D : in std_logic_vector(7 downto 0);
			CLK, E: in std_logic;
			Q: out std_logic_vector (7 downto 0));
end component;

component CLK_DIV1 is
	port(clk : in std_logic;
			sclk : out std_logic);
end component;

component Linear_FB_Register is 
	Port(clk, reset: in std_logic;
	     lfsr8_out: out std_logic_vector (7 downto 0));
end component; 

component sseg_dec is 
	port(ALU_VAL : in std_logic_vector(7 downto 0); 
					 SIGN : in std_logic;
					VALID : in std_logic;
					  CLK : in std_logic;
				 DISP_EN : out std_logic_vector(3 downto 0);
				SEGMENTS : out std_logic_vector(7 downto 0));
end component;
	
signal num_out : std_logic_vector(7 downto 0);
signal s_clk : std_logic;  

begin

CD: CLK_DIV1 port map(
				clk => CLK,
				sclk => s_clk);
				
random_number_generator: Linear_FB_Register port map(
	clk => s_clk,
	reset => reset_btn,
	lfsr8_out => num_out);

DFF: D_FF port map(
	D => num_out,
	CLK => s_clk,
	E => en,
	Q => D_num_out);
	
SSEG: sseg_dec port map(
	ALU_VAL => D_num_out, 
	SIGN => '0', --'0' because don't want to show a minus sign
	VALID => '1', --'1' because want to show decimal number on display
	CLK => clk,
	DISP_EN => anodes,
	SEGMENTS => segments);

end Behavioral;

